<template>
  <div class="dropdown">
    <span
      v-if="selectedOption.name !== undefined"
      class="inline-block align-middle dropbtn"
      @click="toggleMenu()"
    >
      {{ selectedOption.name }}
      <svg-icon name="arrow-down" style="width: 24px; height: 24px;"></svg-icon>
    </span>
    <span
      v-else
      class="inline-block align-middle dropbtn"
      @click="toggleMenu()"
    >
      {{ placeholderText }}
      <svg-icon name="arrow-down" style="width: 24px; height: 24px;"></svg-icon>
    </span>
    <ul v-show="showMenu" class="dropdown__content">
      <li
        v-for="(option, idx) in options"
        :key="idx"
        class="cursor-pointer hover:text-primary"
        @click="updateOption(option)"
      >
        {{ option.name }}
      </li>
    </ul>
  </div>
</template>
<script>
export default {
  name: 'DropDown',
  props: {
    options: {
      type: Array,
      default: null,
    },
    selected: {
      type: Array,
      default: null,
    },
    placeholder: {
      type: String,
      default: '',
    },
    closeOnOutsideClick: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      selectedOption: [],
      showMenu: false,
      placeholderText: 'Lựa chọn',
    }
  },
  mounted() {
    this.selectedOption = this.selected
    if (this.placeholder) {
      this.placeholderText = this.placeholder
    }
    if (this.closeOnOutsideClick) {
      document.addEventListener('click', this.clickHandler)
    }
  },
  beforeDestroy() {
    document.removeEventListener('click', this.clickHandler)
  },
  methods: {
    updateOption(option) {
      this.selectedOption = option
      this.showMenu = false
      this.$emit('updateOption', this.selectedOption)
    },
    toggleMenu() {
      this.showMenu = !this.showMenu
    },
    clickHandler(event) {
      const { target } = event
      const { $el } = this
      if (!$el.contains(target)) {
        this.showMenu = false
      }
    },
  },
}
</script>
